/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(Autodesk.Revit.UI.ExternalCommandData commandData, ref string message, ElementSet elements) { try { Transaction tran = new Transaction(commandData.Application.ActiveUIDocument.Document, "Rooms"); tran.Start(); // create a new instance of class data RoomsData data = new RoomsData(commandData); // create a form to display the information of rooms using (roomsInformationForm infoForm = new roomsInformationForm(data)) { infoForm.ShowDialog(); } tran.Commit(); return(Autodesk.Revit.UI.Result.Succeeded); } catch (Exception ex) { // If there are something wrong, give error information and return failed message = ex.Message; return(Autodesk.Revit.UI.Result.Failed); } }
/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(Autodesk.Revit.UI.ExternalCommandData commandData, ref string message, ElementSet elements) { try { Transaction tran = new Transaction(commandData.Application.ActiveUIDocument.Document, "Rooms"); tran.Start(); // create a new instance of class data RoomsData data = new RoomsData(commandData); // create a form to display the information of rooms using (roomsInformationForm infoForm = new roomsInformationForm(data)) { infoForm.ShowDialog(); } tran.Commit(); return Autodesk.Revit.UI.Result.Succeeded; } catch (Exception ex) { // If there are something wrong, give error information and return failed message = ex.Message; return Autodesk.Revit.UI.Result.Failed; } }
/// <summary> /// Run sample Rooms /// </summary> public void Run() { try { //create a new instance of class Data RoomsData data = new RoomsData(m_doc, m_doc.Document.Application); //create a form to display the room information using (roomsInformationForm infoForm = new roomsInformationForm(data)) { infoForm.ShowDialog(); } } catch (Exception ex) { // If there are something wrong, give error information MessageBox.Show(ex.Message); } }